//: C01:Covariance.cpp {-xo}
// Z knihy "Myslíme v jazyce C++, část 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Všechna práva vyhrazena.
// Přečtěte si podmínky používání zdrojových kódů umístěné v souboru 
// 'Licence.txt' dodávaném spolu s balíčkem kódu dostupným na www.MindView.net.
// Měl by způsobit chybu překladu {-mwcc}{-msc}
#include <iostream>
using namespace std;

class Zakladni {
public:
  class ZakladniVyjimka {};
  class OdvozenaVyjimka : public ZakladniVyjimka {};
  virtual void f() throw(OdvozenaVyjimka) {
    throw OdvozenaVyjimka();
  }
  virtual void g() throw(ZakladniVyjimka) {
    throw ZakladniVyjimka();
  }
};

class Odvozena : public Zakladni {
public:
  void f() throw(ZakladniVyjimka) {
    throw ZakladniVyjimka();
  }
  virtual void g() throw(OdvozenaVyjimka) {
    throw OdvozenaVyjimka();
  }
}; ///:~
